// E-TELSA - A Program to Calculate the Resonant Frequency of Tesla Coils
// This program is released to the public domain
//
// Great thanks to Jim Monte for numerous help and tips
//
// Great thanks to John Damm Soerensen <jdsoerensen@geocities.com>
// for a major speed improvement
//
// Great thanks to Kevin Ottalini for the very fast compiler version
//
// Ported to C++ by Sarah Thompson - needs Qt 1.4 or later (I used Qt 2.01, but 1.4 should be OK)
//
// Sarah's code butchered by Terry to get rid of QTthing and remove functions I didn't understand :-))
//   this allows it to compile under my shareware C thing so I can play with the code too! :-))
// Sarah showed me how to get it to run giant arrays ;-))
//
// Modified by John Damm Soerensen to allow input from a file input.txt
// the aloows for comments as long as the very first character is a *
//
// Version 6!  To take advantage of the wonderful new data from Paul Nicholson's secondary
// modeling project.  Fixed strike rail height bug.  Fixed some compatibility stuff Paul mentioned.
//
// Finally (ha ha!) figured out the Et summation factor is pi^2/sqrt(3) not 3/4pi^2.
// This changes the terminated coil Lfac to 1.000!!
//
// Fixed Soutput.xls scale error for other units of measure.  Added primary height warning.
//


#include <stdio.h>
#include <string.h>
#include <math.h>
#include <malloc.h>
#include <sys/types.h>
#include <sys/stat.h>

#define REV " V6.12Cpaul  May 27, 2001 "

#define mathtype float

int main()

{

	int CountInc = 1000; // The number of passes between printouts
	float Qstr;
	int MultD = 0;
	float pi = 3.14159265359;
	float Cap1 = 1E-15;
	double Et = 0.0;
	double xr = 0.0, yr = 0.0, CircFac = 0.0;
	double vs1 = 0.0, vr = 0.0, vs2 = 0.0, vs = 0.0, Qt = 0.0;
    float Cap = 0.0, Fo = 0.0, Str = 0.0, y_zero = 0.0;
	float Acc = 0.0;
	float Erp = 100.0;
    double Mult = 0.0;
	float nz = 0.0;
	float Lfac = 0.0;
	float Bare = 0.0;
	float Ceil = 0.0;
	float Wall = 0.0;
	double AcF = 0.0;
	float PriH = 0.0;
	float PriD0 = 0.0;
	float PriD = 0.0;
	float PriH1 = 0.0;
	float SecB = 0.0;
	float SecD = 0.0;
	float SecL = 0.0;
	float StriH = 0.0;
	float StriD = 0.0;
	float SecInd = 0.0;
	float TermH = 0.0;
	float TermH2 = 0.0, TermR = 0.0, TermD = 0.0, TermR2 = 0.0, TermV = 0.0, TermD2 = 0.0;
	float Htot = 0.0;
	float g0 = 0.0;
	float z=0.0;
	double Q=0.0;
	float ts=0.0;
	float x=0.0, y=0.0;
	double Vr1 = 0.0, Vr2= 0.0, Vr3 = 0.0, Vr4 = 0.0, Dr1 = 0.0, Dr2=0.0, Dr3=0.0, Dr4=0.0;
	double Qtt;
	int zz = 0, zpcnt = 0;
	long count = 0;
	char buffer[256];
	float StressMax = 0.0;

	mathtype **a;
	int **p;
	int i=0, j=0;
	int xsize = 0;
	int ysize = 0;
	FILE *f;
	FILE *df;
	FILE *fo;
	FILE *vo;
	FILE *so;
	FILE *vso;
	FILE *k;


    printf(" E-TESLA - Tesla Coil Resonant Frequency Calculator\n" REV "\n\n");

line1000:

line2000:
        if( (freopen("input.txt","r",stdin)) == NULL) freopen("con","r",stdin);
	printf(" Input an ARRAY SIZE 100 (min) to 1000 (or more...).\n");
	printf(" The higher the number, the longer it takes to calculate.\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&Acc);
        	break;
        	}
	}

	if(Acc < 100.0 || Acc > 100000.0)
	{
		Acc = floor(Acc);
		printf(" Must be between 100 and 100000!\n");
		goto line2000;
	}

	printf(" Input the measurement UNITs you are using.\n");
    printf(" 1 = mm\n");
    printf(" 2 = cm\n");
    printf(" 3 = inches\n");
    printf(" 4 = feet\n");
    printf(" 5 = meters\n");
    printf(" All dimension inputs will be in these units.\n");

line2100:
	printf(" Units ");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%d",&MultD);
        	break;
        	}
	}

	switch((int) MultD)
	{
	case 1:
		Mult = 0.0393700787402;
		break;

	case 2:
		Mult = 0.393700787402;
		break;

	case 3:
		Mult = 1.0;
		break;

	case 4:
		Mult = 12.0;
		break;

	case 5:
		Mult = 39.3700787402;
		break;

	default:
		printf(" Try again!\n");
		goto line2100;
	}

line2150:
	printf(" Is the secondary BARE or TERMINATED?\n");

    printf(" 1 = BARE\n");
    printf(" 2 = TERMINATED\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&Bare);
        	break;
        	}
	}

    if(Bare != 1.0 && Bare != 2.0)
	{
		printf(" Must input 1 or 2!\n");
		goto line2150;
	}

    if(Bare == 2.0)
	{
		Bare = 0;
	}

line2200:
	printf(" How HIGH is the CEILING?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&Ceil);
        	break;
        	}
	}

    if(Ceil <= 0)
	{
		printf(" Must be greater than zero!\n");
		goto line2200;
	}

line2300:
	printf(" How FAR are the WALLs from the coil?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&Wall);
        	break;
        	}
	}

    if(Wall <= 0)
	{
		printf(" Must be greater than zero!\n");
		goto line2300;
	}

    if(2.0 * Wall < Ceil)
	{
		printf(" The walls are too close to the coil!\n");
		goto line2300;
	}

    AcF = sqrt(Acc * Acc / Ceil / Wall);

line2400:
  	printf(" What is the HEIGHT from the floor to the INNER TURN of the PRIMARY coil?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&PriH);
        	break;
        	}
	}

    if(PriH < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2400;
	}

line2500:
	printf(" What is the INNER DIAMETER of your PRIMARY coil?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&PriD0);
        	break;
        	}
	}

    if(PriD0 < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2500;
	}

line2600:
	printf(" What is the OUTER DIAMETER of your PRIMARY coil?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&PriD);
        	break;
        	}
	}
    if(PriD < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2600;
	}

line2700:
	printf(" What is the HEIGHT from the floor to the OUTER TURN of the PRIMARY?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&PriH1);
        	break;
        	}
	}

    if(PriH1 < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2700;
	}

line2710:
	printf(" What is the HEIGHT from the floor to the STRIKE RAIL (0 if none)?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&StriH);
        	break;
        	}
	}

	if(StriH < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2710;
	}

line2720:
	printf(" What is the DIAMETER of the the STRIKE RAIL loop (0 if none)?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&StriD);
        	break;
        	}
	}

	if(StriD < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2720;
	}

line2800:
	printf(" What is the HEIGHT from the floor to the FIRST WINDING of the SECONDARY coil?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&SecB);
        	break;
        	}
	}

    if(SecB < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2800;
	}

line2900:
	printf(" What is the DIAMETER of your SECONDARY coil?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&SecD);
        	break;
        	}
	}

	if(SecD < 0)
	{
		printf(" Must be greater than or equal to zero!");
		goto line2900;
	}

line3000:
	printf(" What is the LENGTH of your SECONDARY coil?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&SecL);
        	break;
        	}
	}
    if(SecL < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3000;
	}

line3100:
	printf(" What is the INDUCTANCE in MILLI-HENRIES of the SECONDARY?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&SecInd);
        	break;
        	}
	}

    SecInd = SecInd / 1000.0;

    if(SecInd <= 0)
	{
		printf(" Must be greater than zero!\n");
		goto line3100;
	}

    if(Bare == 1.0)
	{
		TermH = SecB + SecL;
		TermH2 = TermH;
		goto line3800;
	}

line3200:
	printf(" What is the HEIGHT from the floor to the CENTER of the FIRST TOP TERMINAL?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&TermH);
        	break;
        	}
	}

    if(TermH < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3200;
	}

    if(TermH == 0)
	{
		TermH = SecB + SecL;
	}

line3300:
	printf(" What is the DIAMETER of the FIRST TERMINAL (sphere or toroid cord)?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&TermR);
        	break;
        	}
	}

    if(TermR < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3300;
	}
	TermR = TermR / 2.0;

line3400:
	printf(" What is the CENTER to CENTER DIAMETER of the TOROID?\n");
    printf(" Enter 0 if it is a sphere.\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&TermD);
        	break;
        	}
	}

    if(TermD < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3400;
	}

line3500:
	printf(" What is the HEIGHT from the floor to the CENTER of the SECOND TOP TERMINAL?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&TermH2);
        	break;
        	}
	}

    if(TermH2 < 0)
	{
		printf(" Must be greater than or equal to zero!");
		goto line3500;
	}

    if(TermH2 < TermH)
	{
		TermH2 = TermH;
	}

line3600:
	printf(" What is the DIAMETER of the SECOND TERMINAL (sphere or toroid cord)?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&TermR2);
        	break;
        	}
	}

    if(TermR2 < 0)
	{
		printf(" Must be greater than or equal to zero!");
		goto line3600;
	}
	TermR2 = TermR2 / 2.0;

line3700:
	printf(" What is the CENTER to CENTER DIAMETER of the TOROID?\n");
    printf(" Enter 0 if it is a sphere.\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&TermD2);
        	break;
        	}
	}

    if(TermD2 < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3700;
	}

line3800:
    TermV = 1.0;
    printf(" What is the TOP VOLTAGE (enter 1 for default)?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&TermV);
			break;
        	}
	}

    if(TermV < 1.0)
	{
		printf(" Must be greater than or equal to 1!\n");
		goto line3800;
	}

    printf(" Grid Size = %lf\n", Acc );
    printf(" Scale Multiplier = %lf\n", Mult);

    if(Bare)
	{
		printf(" Bare Coil\n");
	}
	else
	{
		printf(" Terminated Coil\n");
	}

    printf(" Ceiling Height = %lf\n", Ceil);
    printf(" Wall Distance = %lf\n", Wall);
    printf(" Primary Height (Inner Turn) = %lf\n", PriH);
    printf(" Primary Inner Diameter = %lf\n", PriD0);
    printf(" Primary Outer Diameter = %lf\n", PriD);
    printf(" Primary Height (Outer Turn) = %lf\n", PriH1);
	printf(" Strike Rail Height = %1f\n", StriH);
	printf(" Strike Rail Diameter = %1f\n", StriD);
    printf(" Secondary Base Height = %lf\n", SecB);
    printf(" Secondary Diameter = %lf\n", SecD);
    printf(" Secondary Length = %lf\n", SecL);
    printf(" Secondary Inductance (mH) = %lf\n", SecInd * 1000.0);
    printf(" Terminal-1 Height (center) = %lf\n", TermH);
    printf(" Terminal-1 Cord Diameter = %lf\n", 2.0 * TermR);
    printf(" Terminal-1 C-C Diameter (toroid only) = %lf\n", TermD);
    printf(" Terminal-2 Height (center) = %lf\n", TermH2);
    printf(" Terminal-2 Cord Diameter = %lf\n", 2.0 * TermR2);
    printf(" Terminal-2 C-C Diameter (toroid only) = %lf\n", TermD2);
    printf(" Top Voltage = %lf\n", TermV);

	if(Wall > Ceil)
		{
			printf(" WARNING! - Walls are further than the ceiling height.\n");
		}

	if(SecL < 0.25 * Ceil)
		{
			printf(" WARNING! - Coil is less than 1/4 of the room height.\n");
		}

	if(SecB < PriH)
		{
			printf(" WARNING! - Primary height is greater than secondary base height.\n");
		}

    printf(" Is this correct (y=1/n=0) ?\n");

	while (1)
	{
	buffer[0]= (char)0;
	fgets(buffer,256,stdin);
	if ( buffer[0] != '*')
        	{
        	sscanf(buffer,"%f",&Qstr);
        	break;
        	}
	}

    if(Qstr == 0.0)
	{
		goto line1000;
	}

// Factor Acf so coil diameter falls directly on grid points

    AcF = AcF * floor(AcF * SecD / 2.0) / (AcF * SecD / 2.0);

// Store Inputs to File
	f = fopen("output.txt", "w");

	fprintf(f, " E-TESLA " REV "\n");
    fprintf(f, "  \n");
    fprintf(f, " Grid Size = %lf\n", Acc );
    fprintf(f, " Scale Multiplier = %lf\n", Mult);

    if(Bare)
	{
		fprintf(f, " Bare Coil\n");
	}
	else
	{
		fprintf(f, " Terminated Coil\n");
	}

    fprintf(f, " Ceiling Distance = %lf\n", Ceil);
	Ceil = floor(Ceil * AcF + 0.5);

    fprintf(f, " Wall Distance = %lf\n", Wall);
	Wall = floor(Wall * AcF + 0.5);

    fprintf(f, " Primary Height (Inner Turn) = %lf\n", PriH);
	PriH = floor(PriH * AcF + 0.5);

    fprintf(f, " Primary Inner Diameter = %lf\n", PriD0);
	PriD0 = floor(PriD0 * AcF + 0.5);

    fprintf(f, " Primary Outer Diameter = %lf\n", PriD);
	PriD = floor(PriD * AcF + 0.5);

    fprintf(f, " Primary Height (Outer Turn) = %lf\n", PriH1);
	PriH1 = floor(PriH1 * AcF + 0.5);

	fprintf(f, " Strike Rail Height = %1f\n", StriH);
	StriH = floor(StriH * AcF + 0.5);

	fprintf(f, " Strike Rail Diameter = %1f\n", StriD);
	StriD = floor(StriD * AcF + 0.5);

    fprintf(f, " Secondary Base Height = %lf\n", SecB);
	SecB = floor(SecB * AcF + 0.5);

    fprintf(f, " Secondary Diameter = %lf\n", SecD);
	SecD = SecD * AcF;

    fprintf(f, " Secondary Length = %lf\n", SecL);
	SecL = floor(SecL * AcF + .5);

    fprintf(f, " Secondary Inductance (mH) = %lf\n", SecInd * 1000.0);

    fprintf(f, " Terminal-1 Height (center) = %lf\n", TermH);
	TermH = floor(TermH * AcF + .5);

    fprintf(f, " Terminal-1 Cord Diameter = %lf\n", 2.0 * TermR);
	TermR = TermR * AcF;

    fprintf(f, " Terminal-1 C-C Diameter (toroid only)= %lf\n", TermD);
	TermD = TermD * AcF;

    fprintf(f, " Terminal-2 Height (center) = %lf\n", TermH2);
	TermH2 = floor(TermH2 * AcF + .5);

    fprintf(f, " Terminal-2 Cord Diameter = %lf\n", 2.0 * TermR2);
	TermR2 = TermR2 * AcF;

    fprintf(f, " Terminal-2 C-C Diameter (toroid only)= %lf\n", TermD2);
	TermD2 = TermD2 * AcF;

    fprintf(f, " Top Voltage = %lf\n", TermV);

    fprintf(f, " Pass     Ccalc (pF)          Change            Fcalc (Hz)\n");

	fclose(f);

// Htot is the total effective height of the coil
// g0 is the radius of the Gaussian sphere

    Htot = TermR + TermD / 2.0 + TermH;

    if(Htot < TermH2 + TermR2 + TermD2 / 2.0)
	{
		Htot = TermH2 + TermR2 + TermD2 / 2.0;
	}

    g0 = floor(((Htot - SecB) + (Ceil - SecB)) / 4.0 + 0.5);

    printf(" Calculations are now under way!\n\n");

	printf(" Type CONTROL-C to stop.\n\n");

    printf(" Pass     Ccalc (pF)          Change            Fcalc (Hz)\n");

	xsize = ((int)Wall) + 4;
	ysize = ((int)Ceil) + 4;

	a = (mathtype **) calloc(xsize, sizeof(mathtype *));
	p = (int **) calloc(xsize, sizeof(int *));

	for(i=0; i<xsize; i++)
	{
		a[i] = (mathtype *) calloc(ysize, sizeof(mathtype *));
		p[i] = (int *) calloc(ysize, sizeof(mathtype *));

		for(j=0; j<ysize; j++)
		{
			a[i][j] = 0.0;
			p[i][j] = 0;
		}
	}

// Set initial conditions and lock bondaries
	// Array "a" is the numeric array
	// Array "p" is the protection array.  If non-zero, the program will not over write
	// those locations (bondary conditions).

// Primary Coil

    for(z = PriD0 / 2.0; z <= PriD / 2.0; z++)
	{
	    Q = PriD / 2.0 - SecD / 2.0;

	    a[(int)(z+0.5)][(int)((PriH + (PriH1 - PriH) * (z - SecD / 2) / Q)+0.5)] = 0.0;
	    p[(int)(z+0.5)][(int)((PriH + (PriH1 - PriH) * (z - SecD / 2) / Q)+0.5)] = 1;
	}

// Strike Rail
	a[(int)(StriD / 2 + 0.5)][(int)(StriH + 0.5)] =0.0;
	p[(int)(StriD / 2 + 0.5)][(int)(StriH + 0.5)] =1;

// Voltage Along Secondary

	// Terminated Case Secondary Voltage Profile
	    if(Bare == 0.0)
			{
			for(z = SecB; z <= SecB + SecL; z++)
				{
				// Normalize z for 0-1 along secondary for curve fitted equations
				nz = (z - SecB) / SecL;

				// Paul suggests that the secondary inductance is less than the measured
				// Ldc inductance.  Lfac is this factor
				Lfac = 1.0;

// v = 0.95 x + 0.35 x^2 - 0.29 x^3 (normalized) is the equation used.

				a[(int)(0.5 + SecD / 2.0)][(int)(z + 0.5)] = TermV *
					(0.95 * nz + 0.35 * nz * nz - 0.29 * nz * nz * nz);

	  			p[(int)(0.5 + SecD / 2.0)][(int)(z + 0.5)] = 1;
				}
			}

	// Bare Case Secondary Voltage Profile
		else
			{
			for(z = SecB; z <= SecB + SecL; z++)
				{
				// Normalize z for 0-1 along secondary for curve fitted equations
				nz = (z - SecB) / SecL;

				// Paul suggests that the secondary inductance is less than the measured
				// Ldc inductance.  Lfac is this factor
				Lfac = 0.9321355;

// v = x + 0.65 x^2 - 0.64 x^3 (normalized) is the equation used.

				a[(int)(0.5 + SecD / 2.0)][(int)(z + 0.5)] = TermV *
					(nz + 0.65 * nz * nz - 0.64 * nz * nz * nz);

	  			p[(int)(0.5 + SecD / 2.0)][(int)(z + 0.5)] = 1;
				}
			}


// Top of Secondary to Top Terminal-1
    for(z = SecB + SecL; z <= TermH; z++)
	{
	    a[(int)(0)][(int)(z+0.5)] = TermV;
	    p[(int)(0)][(int)(z+0.5)] = 1.0;
	}

// Out to Radius-1
    for(z = 0; z <= TermD / 2.0; z++)
	{
	    a[(int)(z+0.5)][(int)(TermH+0.5)] = TermV;
	    p[(int)(z+0.5)][(int)(TermH+0.5)] = 1.0;
	}

// Terminal-1 Radius
    for(z = -pi / 2.0; z <= pi / 2.0; z += 0.0785)
	{
	    x = TermD / 2.0 + TermR * cos(z);
		y = TermH + TermR * sin(z);

	    a[(int)(x+0.5)][(int)(y+0.5)] = TermV;
	    p[(int)(x+0.5)][(int)(y+0.5)] = 1.0;

	    if(TermD / 2.0 + 1.0 >= TermR) // Comparison swapped from < to >= to avoid need for goto -- SJT
		{
		    x = TermD / 2.0 - TermR * cos(z);
		    a[(int)(x+0.5)][(int)(y+0.5)] = TermV;
		    p[(int)(x+0.5)][(int)(y+0.5)] = 1.0;
		}
	}

    a[(int)(0.5 + TermD / 2.0)][(int)(0.5 + TermH + TermR)] = TermV;
    a[(int)(0.5 + TermD / 2.0)][(int)(0.5 + TermH - TermR)] = TermV;

    p[(int)(0.5 + TermD / 2.0)][(int)(0.5 + TermH + TermR)] = 1.0;
    p[(int)(0.5 + TermD / 2.0)][(int)(0.5 + TermH - TermR)] = 1.0;

// Top of Terminal-1 to Top of Terminal-2
    for(z = TermH; z <= TermH2; z++)
	{
	    a[(int)(0)][(int)(0.5 + z)] = TermV;
	    p[(int)(0)][(int)(0.5 + z)] = 1.0;
	}

// Out to Radius-2
    for(z = 0.0; z <= TermD2 / 2.0; z++)
	{
	    a[(int)(0.5 + z)][(int)(0.5 + TermH2)] = TermV;
	    p[(int)(0.5 + z)][(int)(0.5 + TermH2)] = 1;
	}

// Terminal-2 Radius
    for(z = -pi / 2.0; z <= pi / 2.0; z += 0.0785)
	{
	    x = TermD2 / 2.0 + TermR2 * cos(z);
		y = TermH2 + TermR2 * sin(z);

	    a[(int)(0.5 + x)][(int)(0.5 + y)] = TermV;
	    p[(int)(0.5 + x)][(int)(0.5 + y)] = 1.0;

	    if(TermD2 / 2.0 + 1.0 >= TermR2) // Comparison sign changed from < to >= to avoid goto -- SJT
		{
		    x = TermD2 / 2.0 - TermR2 * cos(z);
		    a[(int)(0.5 + x)][(int)(0.5 + y)] = TermV;
		    p[(int)(0.5 + x)][(int)(0.5 + y)] = 1.0;
		}
	}

    a[(int)(0.5 + TermD2 / 2.0)][(int)(0.5 + TermH2 + TermR2)] = TermV;
    a[(int)(0.5 + TermD2 / 2.0)][(int)(0.5 + TermH2 - TermR2)] = TermV;
    p[(int)(0.5 + TermD2 / 2.0)][(int)(0.5 + TermH2 + TermR2)] = 1.0;
    p[(int)(0.5 + TermD2 / 2.0)][(int)(0.5 + TermH2 - TermR2)] = 1.0;

// Mark Gaussian surface on protection array for diagnostics
    y_zero = g0 + PriH + 0.5;

    for(ts = -1.57; ts <= 1.57; ts += .001)
	{
	    xr = cos(ts) * (g0 - 0.5);
	    yr = sin(ts) * (g0 - 0.5) + y_zero;
	    p[(int)(0.5 + xr)][(int)(0.5 + yr)] = -1;
	}

// Output the diagnostic grid to a file for Excel
	df = fopen("diag.xls", "w");

	int xpcnt, ypcnt;

    for(ypcnt = Ceil; ypcnt >= 0; ypcnt--)
	{
		for(xpcnt = Wall; xpcnt >= 0; xpcnt--)
		{
		    fprintf(df, "%d ", p[xpcnt][ypcnt]);
		}

	    // Mirror left side
	    for(xpcnt = 1; xpcnt <= Wall; xpcnt++)
		{
		    fprintf(df, "%d ", p[xpcnt][ypcnt]);
		}

	    fprintf(df, "\n");
	}

	fclose(df);

// 30000 'Main Loop
line30000:

    for(zz = 1; zz <= CountInc; zz++)
	{
	    for(ypcnt = 1; ypcnt < Ceil; ypcnt ++)
		{
			for(xpcnt = 1; xpcnt < Wall; xpcnt++)
			{
			    if(p[xpcnt][ypcnt] <= 0) // Sign flipped to avoid goto
				{
				    a[(int)(xpcnt)][(int)(ypcnt)] = 0.25 * (a[(int)(xpcnt + 1)][(int)(ypcnt)]
						+ a[(int)(xpcnt - 1)][(int)(ypcnt)]
						+ a[(int)(xpcnt)][(int)(ypcnt + 1)]
						+ a[(int)(xpcnt)][(int)(ypcnt - 1)]);

				    a[(int)(xpcnt)][(int)(ypcnt)] = a[(int)(xpcnt)][(int)(ypcnt)]
						+ (a[(int)(xpcnt + 1)][(int)(ypcnt)] - a[(int)(xpcnt - 1)][(int)(ypcnt)])
						/ ((float)(8.0 * xpcnt));
				}
			}
		}

	    for(zpcnt = 1; zpcnt < Ceil; zpcnt++)
		{
		    if(p[0][zpcnt] <= 0) // Sign flipped to avoid goto
			{
			    a[(int)(0)][(int)(zpcnt)] = (4.0 * a[(int)(1)][(int)(zpcnt)] + a[(int)(0)][(int)(zpcnt - 1)] + a[(int)(0)][(int)(zpcnt + 1)]) / 6.0;
			}
		}
	}

    count = count + CountInc;

// Calculate E-field by summing all flux through a sphere

line33000:

    Et = 0.0;
    y_zero = g0 + PriH + 0.5;

    for(ts = -1.5708; ts <= 1.5708; ts += .0001)
	{
    	// CircFac is the area of the section of the sphere
	    CircFac = (sin(ts + 0.00005) - sin(ts - 0.00005));

	    xr = cos(ts) * (g0 - 0.5);
	    yr = sin(ts) * (g0 - 0.5) + y_zero;

			Vr1 = a[(int)(xr)][(int)(yr)];
     		Vr2 = a[(int)(xr + 1)][(int)(yr)];
     		Vr3 = a[(int)(xr)][(int)(yr + 1)];
     		Vr4 = a[(int)(xr + 1)][(int)(yr + 1)];
     		Dr1 = sqrt(pow(floor(xr), 2.0) + pow((floor(yr) - y_zero), 2.0));
     		Dr2 = sqrt(pow(floor(xr + 1.0), 2.0) + pow((floor(yr) - y_zero), 2.0));
     		Dr3 = sqrt(pow(floor(xr), 2.0) + pow(floor(yr + 1) - y_zero, 2.0));
     		Dr4 = sqrt(pow(floor(xr + 1.0), 2.0) + pow(floor(yr + 1) - y_zero, 2.0));

     		Qtt = (Vr1 / Dr1 + Vr2 / Dr2 + Vr3 / Dr3 + Vr4 / Dr4) / 4.0;

     		vr = Qtt * sqrt(pow(xr, 2.0) + pow((yr - y_zero), 2.0));

	    vs1 = vr;
	    xr = cos(ts) * (g0 + 0.5);
	    yr = sin(ts) * (g0 + 0.5) + y_zero;

			Vr1 = a[(int)(xr)][(int)(yr)];
     		Vr2 = a[(int)(xr + 1)][(int)(yr)];
     		Vr3 = a[(int)(xr)][(int)(yr + 1)];
     		Vr4 = a[(int)(xr + 1)][(int)(yr + 1)];
     		Dr1 = sqrt(pow(floor(xr), 2.0) + pow((floor(yr) - y_zero), 2.0));
     		Dr2 = sqrt(pow(floor(xr + 1.0), 2.0) + pow((floor(yr) - y_zero), 2.0));
     		Dr3 = sqrt(pow(floor(xr), 2.0) + pow(floor(yr + 1) - y_zero, 2.0));
     		Dr4 = sqrt(pow(floor(xr + 1.0), 2.0) + pow(floor(yr + 1) - y_zero, 2.0));

     		Qtt = (Vr1 / Dr1 + Vr2 / Dr2 + Vr3 / Dr3 + Vr4 / Dr4) / 4.0;

     		vr = Qtt * sqrt(pow(xr, 2.0) + pow((yr - y_zero), 2.0));

	    vs2 = vr;
	    vs = (vs1 - vs2);
	    Et = Et + vs * CircFac;
	}

    Et = Et * pi * pi / sqrt(3.0) * g0 * g0 / AcF / 39.3700787402;

// Calculate the capacitance

    Qt = 8.854187818E-12 * Et * Mult;
    Cap = Qt / TermV;
    Erp = (Cap - Cap1) / Cap1 * 100.0;
    if(Cap < 0.0)
	{
		Fo = 0.0;
	}
	else
	{

		// Paul suggest that the seconary inductance needs to be multiplied by a factor
		// (Lfac) to account for the non-uniform secondary current.

	    Fo = 1.0 / (2.0 * pi * sqrt(SecInd * Lfac * Cap));
	}

	printf("%1f\n", StressMax);

	printf("%6ld   ", count);
    printf("C=%3.5f       Err%%=%4.6f       F=%7.2f\n", Cap * 1E+12, Erp, Fo);

	fo = fopen("output.txt", "a");

	fprintf(fo, "%6ld   ", count);
    fprintf(fo, "C=%3.5f       Err%%=%4.6f       F=%7.2f\n", Cap * 1E+12, Erp, Fo);

    Cap1 = Cap;

	fclose(fo);

// Output the whole voltage grid space to a file for Excel
	vo = fopen("voutput.xls", "w");

    for(ypcnt = Ceil; ypcnt >= 0; ypcnt--)
	{
		for(xpcnt = Wall; xpcnt >= 0; xpcnt --)
		{
		    fprintf(vo, "%lf ", a[(int)(xpcnt)][(int)(ypcnt)]);
		}

	    // Mirror left side
	    for(xpcnt = 1; xpcnt <= Wall; xpcnt ++)
		{
		    fprintf(vo, "%lf ", a[(int)(xpcnt)][(int)(ypcnt)]);
		}

	    fprintf(vo, "\n");
	}

	fclose(vo);

// Output the whole stress grid space to a file for Excel
	so = fopen("soutput.xls", "w");

	StressMax = 0;

    for(ypcnt = Ceil - 1; ypcnt >= 1; ypcnt--)
	{
		for(xpcnt = Wall - 1; xpcnt >= 1; xpcnt--)
		{
		    Str = (fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt - 1)][(int)(ypcnt)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt + 1)][(int)(ypcnt)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt)][(int)(ypcnt + 1)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt)][(int)(ypcnt - 1)])) / 4.0;

		    fprintf(so, "%lf ", Str * AcF / Mult);


			if(StressMax < Str * AcF / Mult)
				{
					StressMax = Str * AcF / Mult;
				}

		}

	    // Mirror left side
	    for(xpcnt = 1; xpcnt < Wall; xpcnt++)
		{
		    Str = (fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt - 1)][(int)(ypcnt)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt + 1)][(int)(ypcnt)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt)][(int)(ypcnt + 1)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt)][(int)(ypcnt - 1)])) / 4.0;

	    	fprintf(so, "%lf ", Str * AcF / Mult);
		}

    	fprintf(so, "\n");

	k = fopen("StressMax.txt", "w");
	fprintf(k, "%1f\n", StressMax);
	fclose (k);

	}

	fclose(so);

	if(count < CountInc)
	{
		goto line30000;
	}

    if(Erp < 0.0001)
	{
		goto line49999;
	}

	goto line30000;

line49999:

    printf(" type any key and press return ?\n");
        freopen("con","r",stdin);
	scanf( "%s", &Qstr );
 	return 0;

}


